#!/bin/env python
#Example of an Asynchronous call to a service
#the service actually works on our server but is not registrated on bioMoby
import time


def generateRandomAAFastaSequence():
    AA1 = "ACDEFGHIKLMNPQRSTVWY"

    import random

    length=random.randint(50,450)

    seq=">random sequence\n"

    while length>0:
        i=random.randint(0,len(AA1)-1)
        seq=seq+AA1[i]
        length-=1

    return seq


from bioMoby import MobyFASTA, MobyContent, Parameter
from SOAPpy import SOAPProxy

s=SOAPProxy("http://bioserv.rpbs.jussieu.fr/RPBS/cgi-bin/wsRessource.py")

#Blastpgp parameters
pe=Parameter("e","5.0")
pm=Parameter("M","BLOSUM80")

mQueries={}

#We put 30 queries in our Content Object
for i in range(1,30):
    mQueries['query%s'%i]=[MobyFASTA(content=generateRandomAAFastaSequence()), pe, pm]

#Build the MobyContent Object
mc=MobyContent(mQueries)

#Call the webservice
r=s.Blastpgp(str(mc))

#Deserialize the object with the MobyUnmarshaller
from bioMoby import MobyUnmarshaller

um=MobyUnmarshaller()

mc=um.loads(r)

#If we got a JOBSESSION key, wait and resend the MobyContent again
while 'JOBSESSION' in mc.keys():
    time.sleep(60)
    r=s.Blastpgp(str(mc))
    mc=um.loads(r)

#Print the results finally
for query in mc.keys():
    print query+"="
    print mQueries[query][0].content
    print "result="
    print mc[query][0].content
